package agents

import (
	"context"

	"gitea.stevedudenhoeffer.com/steve/answer/pkg/agents/console"
)

// Console will construct a console.Agent, execute the agent, and return the knowledge gained, the output directory,
// and any possible error.
func (a Agent) Console(ctx context.Context, questions []string) (Knowledge, string, error) {
	con := console.Agent{
		Agent:                 a,
		Model:                 a.model,
		ContextualInformation: a.contextualInformation,
		MaxCommands:           50,
	}

	res, err := con.Answer(ctx, questions)
	if err != nil {
		return Knowledge{}, "", err
	}

	return res.Knowledge, res.Directory, nil
}
